# abstract class CSV::Lexer

- CSV::Lexer
- Reference
- Object

##
Overview

A CSV lexer lets you consume a CSV token by token. You can use this to efficiently parse a CSV without the need to allocate intermediate arrays.

    require "csv"

    lexer = CSV::Lexer.new "one,two\nthree"
    lexer.next_token # => CSV::Token(@kind=Cell, @value="one")
    lexer.next_token # => CSV::Token(@kind=Cell, @value="two")
    lexer.next_token # => CSV::Token(@kind=Newline, @value="two")
    lexer.next_token # => CSV::Token(@kind=Cell, @value="three")
    lexer.next_token # => CSV::Token(@kind=Eof, @value="three")

##
Defined in:

##
Constructors

- .new(string : String, separator = DEFAULT_SEPARATOR, quote_char = DEFAULT_QUOTE_CHAR)

  Creates a CSV lexer from a `String`.

- .new(io : IO, separator = DEFAULT_SEPARATOR, quote_char = DEFAULT_QUOTE_CHAR)

  Creates a CSV lexer from an `IO`.

##
Instance Method Summary

- #next_token

  Returns the next `Token` in this CSV.

- #quote_char : Char
- #separator : Char
- #token : Token

  Returns the current `Token`.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(string : String, separator = DEFAULT_SEPARATOR, quote_char = DEFAULT_QUOTE_CHAR) #

Creates a CSV lexer from a `String`.

def self.new(io : IO, separator = DEFAULT_SEPARATOR, quote_char = DEFAULT_QUOTE_CHAR) #

Creates a CSV lexer from an `IO`.

##
Instance Method Detail

def next_token #

Returns the next `Token` in this CSV.

def quote_char : Char #
def separator : Char #
def token : Token #

Returns the current `Token`.